### https://codedrills.io/problems/red-and-blue

<div data-v-44f69efa="" class="pl-5 pr-2 py-5 v-card v-sheet theme--light"><div data-v-7876bdfe="" data-v-44f69efa=""><p data-v-7876bdfe="">Bob has a string <code data-v-7876bdfe="">S</code> of length <code data-v-7876bdfe="">N</code> in which each character represents a colour, either Red (represented by <code data-v-7876bdfe="">R</code>) or Blue (represented by <code data-v-7876bdfe="">B</code>).</p> <p data-v-7876bdfe="">He also has an array <code data-v-7876bdfe="">D</code> of length <code data-v-7876bdfe="">N</code>, where each element is a non-negative integer.</p> <p data-v-7876bdfe="">In one move, Bob can select any index <code data-v-7876bdfe="">i</code> between <code data-v-7876bdfe="">1</code> and <code data-v-7876bdfe="">N</code> and spill the colour <code data-v-7876bdfe="">S[i]</code> from index <code data-v-7876bdfe="">i + 1</code> to <code data-v-7876bdfe="">i + D[i]</code> (both inclusive). That is, the characters at indexes <code data-v-7876bdfe="">i + 1</code>, ..., <code data-v-7876bdfe="">i + D[i]</code> are set to <code data-v-7876bdfe="">S[i]</code> if <code data-v-7876bdfe="">D[i] &gt; 0</code>.</p> <p data-v-7876bdfe="">Bob wants to make the entire string <strong data-v-7876bdfe="">Red</strong> in colour. That is, all characters in <code data-v-7876bdfe="">S</code> should be equal to <code data-v-7876bdfe="">R</code>.</p> <p data-v-7876bdfe="">Help him find the <strong data-v-7876bdfe="">minimum</strong> number of moves to do so.
If this is impossible, print <code data-v-7876bdfe="">-1</code>.</p> <h2 data-v-7876bdfe="" id="input-format">Input Format</h2> <ul data-v-7876bdfe=""><li data-v-7876bdfe="">The first line of input contains an integer <code data-v-7876bdfe="">T</code>, the number of test cases.</li> <li data-v-7876bdfe="">The following lines describe the test cases. In each test case:
<ul data-v-7876bdfe=""><li data-v-7876bdfe="">The first line contains the integer <code data-v-7876bdfe="">N</code>.</li> <li data-v-7876bdfe="">The second line contains the string <code data-v-7876bdfe="">S</code>, containing <code data-v-7876bdfe="">N</code> characters.</li> <li data-v-7876bdfe="">The third line contains <code data-v-7876bdfe="">N</code> space separated integers, <code data-v-7876bdfe="">D[1], D[2], ... D[N]</code></li></ul></li></ul> <br data-v-7876bdfe=""> <h2 data-v-7876bdfe="" id="constraints">Constraints</h2> <ul data-v-7876bdfe=""><li data-v-7876bdfe=""><code data-v-7876bdfe="">1 ≤ T ≤ 2500</code></li> <li data-v-7876bdfe=""><code data-v-7876bdfe="">1 ≤ N ≤ 1,000,000</code></li> <li data-v-7876bdfe=""><code data-v-7876bdfe="">0 ≤ D[i] ≤ N - i</code> for all <code data-v-7876bdfe="">1 ≤ i ≤ N</code></li> <li data-v-7876bdfe="">The sum of <code data-v-7876bdfe="">N</code> over all testcases doesn't exceed <code data-v-7876bdfe="">1,000,000</code>.</li></ul> <br data-v-7876bdfe=""> <h2 data-v-7876bdfe="" id="output-format">Output Format</h2> <p data-v-7876bdfe="">For each testcase, print a new line with the minimum number of moves required to make the entire string Red in colour. If it is impossible, print <code data-v-7876bdfe="">-1</code>.</p> <h2 data-v-7876bdfe="" id="sample">Sample</h2> <h3 data-v-7876bdfe="" id="input">Input</h3> <div data-v-30045d83="" data-v-7876bdfe="" class="row"><div data-v-30045d83="" class="col col-12"><pre data-v-7876bdfe="" data-v-30045d83="">3
3
RRB
2 1 0
3
RRR
1 1 0
3
RRB
1 0 0
</pre></div></div> <h3 data-v-7876bdfe="" id="output">Output</h3> <div data-v-30045d83="" data-v-7876bdfe="" class="row"><div data-v-30045d83="" class="col col-12"><pre data-v-7876bdfe="" data-v-30045d83="">1
0
-1
</pre></div></div> <h3 data-v-7876bdfe="" id="explanation">Explanation</h3> <ul data-v-7876bdfe=""><li data-v-7876bdfe="">In the first testcase, if index <code data-v-7876bdfe="">1</code> is selected, indexes <code data-v-7876bdfe="">2</code> and <code data-v-7876bdfe="">3</code> are coloured Red. Hence, after one operation, the entire string turns Red in colour.</li> <li data-v-7876bdfe="">In the second testcase, all characters of the string are already <code data-v-7876bdfe="">R</code> so no changes need to be made.</li> <li data-v-7876bdfe="">In the third testcase, it is impossible to change the last character of the string to <code data-v-7876bdfe="">R</code>.</li></ul></div><hr data-v-44f69efa="" role="separator" aria-orientation="horizontal" class="mt-5 v-divider theme--light"><div data-v-44f69efa="" class="row"><div data-v-44f69efa="" class="col-md-3 col-lg-2 col-6"><div data-v-2b3292b4="" data-v-44f69efa="" tabindex="-1" class="v-list-item v-list-item--two-line theme--light"><div data-v-2b3292b4="" class="v-list-item__content"><div data-v-2b3292b4="" class="v-list-item__title subtitle-2">Time Limit</div><div data-v-2b3292b4="" class="v-list-item__subtitle body-1"> 1000 ms </div></div></div></div><div data-v-44f69efa="" class="col-md-3 col-lg-2 col-6"><div data-v-2b3292b4="" data-v-44f69efa="" tabindex="-1" class="v-list-item v-list-item--two-line theme--light"><div data-v-2b3292b4="" class="v-list-item__content"><div data-v-2b3292b4="" class="v-list-item__title subtitle-2">Memory Limit</div><div data-v-2b3292b4="" class="v-list-item__subtitle body-1"> 262144 KiB </div></div></div></div><div data-v-44f69efa="" class="spacer"></div></div></div>

---
#### Solution

```python

def get(A, D):
    ans, covered, fixed = 0, -1, -1
    for i in range(len(A)):
        if i > fixed and A[i] == 'B':
            if i > covered: return -1
            ans += 1
            fixed = covered
        covered = max(covered, i + D[i])
    return ans
        
for t in range(int(input())):
    N = int(input())
    print(get(input(), list(map(int, input().split()))))

```
